#!/usr/bin/python
#-*- coding: utf-8 -*-
#/******************************************************************************
#*                       Pyfocus                                    *
#*******************************************************************************
#*                                                                             *
#*           Copyright (C) 2007  JB BUTET                               *
#*                                                                             *
#*                                                                             *
#*  This program is free software; you can redistribute it and/or modify       *
#*  it under the terms of the GNU General Public License as published by       *
#*  the Free Software Foundation; either version 2 of the License, or          *
#*  (at your option) any later version.                                        *
#*                                                                             *
#*  This program is distributed in the hope that it will be useful,            *
#*  but WITHOUT ANY WARRANTY; without even the implied warranty of             *
#*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
#*  GNU General Public License for more details.                               *
#*                                                                             *
#*  You should have received a copy of the GNU General Public License          *
#*  along with this program; if not, write to the Free Software                *
#*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
#*                                                                             *
#*                                                                             *
#*                                                                             *
#*  For further information contact me at ashashiwa@gmail.com             *
#******************************************************************************/


from PyQt4.QtGui import *
from PyQt4.QtCore import *
from PIL import Image, ImageOps
import sys, os, thread, time, commands, tempfile
import dbus, sys
import dbus.mainloop.qt
from math import sqrt
from UI_pyfocus  import Ui_pyfocus_MainWindow
from UI_zoom_dialog import Ui_Dialog_zoom
from scipy import array, arange, corrcoef
#from pylab import *
from math import cos, sin
#from pylab import *
from correl import Star_Ref, Champ


class camera(QObject):
    """thid object is a camera"""
    def __init__(self,parent):
        QObject.__init__(self)
        self.name = "No Camera "
        self.LastPictureName = None
        self.IsConnected = False
        self.isAutomated=False
        self.haveshutter_list=False
        self.connection = "any ports"
        self.HasPicture = False
        #self.detect_camera() #when lauch-> after it's dbus stuff
        self.bus = dbus.SystemBus()
        self.bus.add_signal_receiver(self.handle_signal, None, None, None)
        self.parent=parent
        self.IsInitialised=False

    def camera_state(self):
        print self.IsConnected, "on", self.connection,  "automated : ", self.isAutomated, "last picture", self.LastPictureName, self.HasPicture

    def handle_signal(self,*args):
        #print 'received signal:', args
        hal_manager_obj = self.bus.get_object("org.freedesktop.Hal", "/org/freedesktop/Hal/Manager")
        hal_manager = dbus.Interface(hal_manager_obj, "org.freedesktop.Hal.Manager")
        
        device_names = hal_manager.GetAllDevices()
        self.camera_is_not_here()
        for name in device_names:
            device_dbus_obj = self.bus.get_object("org.freedesktop.Hal" ,name)
            properties = device_dbus_obj.GetAllProperties(dbus_interface="org.freedesktop.Hal.Device")
            
            try :
                if "camera" in properties["info.capabilities"] :
                    parent = properties["info.parent"]
                    #print parent
                    parent_obj = self.bus.get_object("org.freedesktop.Hal" ,parent)
                    prop_parent = parent_obj.GetAllProperties(dbus_interface="org.freedesktop.Hal.Device")
                    self.name = prop_parent["usb_device.product"]
                    self.connection = prop_parent['linux.subsystem']
                    self.IsConnected = True
		    if self.haveshutter_list==False:
			    self.time_shutter_get_list()
                    print "camera", self.name, " detected"
            except KeyError :
                    pass
        self.parent.update_camera_state(self.IsConnected)
        
    def time_shutter_get_list(self):
        """detect shutterspee available"""
        #print "time shutter list"
        if self.haveshutter_list == False :
            status, output=commands.getstatusoutput('gphoto2 --get-config shutterspeed')
            output=output.splitlines()
            self.shutter_speed_list={}
            if len(output)<20:
                self.isAutomated=False

            else :
                for e in output :
                    if "Choice" in e:
                        if "second" in e:
                            if eval(e.split()[2])!=0 :
                                self.shutter_speed_list[e.split()[1]]=e.split()[2]
                self.isAutomated=True
            self.haveshutter_list = True
           # print self.shutter_speed_list
        
        #self.shutter_speed_list={ 1: 30,  2: 25  ,  3: 20  ,  4: 15  ,  5 :13  ,  6 :10  ,  7: 8  ,  8: 6  ,  9 :5  ,  10 :4  ,  11 :3.2  ,  12 :2.5  ,  13 :2  ,  14: 1.6  ,  15 :1.3  ,  16 :1  }

            
    def camera_is_here(self):
        
        self.IsConnected=True
        self.time_shutter_get_list()
        #print "name, connection", self.name, self.connection
        
        #time.sleep(0.5)
        
    
    def camera_is_not_here(self):
        self.name = self.tr("No Camera ")
        self.connection = self.tr("any ports")
        self.IsConnected=False

    def WhichLastPicture(self):
        """select last picture took and load it in self.lasPicture"""
        #print self.IsConnected
        if self.IsConnected==False :
            pass
            #avert = avertissement(title = "ERREUR !" , principale = None)
        else :
            #list all camera files
            output,liste_photo=commands.getstatusoutput('gphoto2 -L')
            AllFileList=liste_photo.splitlines() #coupe_sortie est la liste de toute la sortie standard
            #print "Camera File list", AllFileList
            #print output, liste_photo
            nbphoto=[]
            #print AllFileList
            for e in AllFileList: #e is a line
                try :
                    nb = e.split()[0]  # #97
                    e.split()[0].rindex('#')
                    if "JPG" in e.split()[1] or "JPEG" in e.split()[1] or "jpg" in e.split()[1] or "jpeg" in e.split()[1] or "CR2" in e.split()[1] :
                        nbphoto.append(nb)
                        nbphoto.append(e.split()[1]) #ajoute le nom de la photo
		except :
                    pass
            try :
                LastPictureNumber=nbphoto[-2] #last Picture number. ex #97
                LastPictureNumber=LastPictureNumber.replace("#"," ")
                self.LastPictureNumber=LastPictureNumber.strip()#recupere le numero propre. ex : '97'
                #self.LastPictureName=nbphoto[-1]
                
		if nbphoto[-1].split(".")[-1]!="CR2":
		    self.LastPictureName = self.LastPictureName=nbphoto[-1]
		else :
		    #extractjpgfromrawcommand ="dcraw -e "+nbphoto[-1]
                    #print extractjpgfromrawcommand
                    #status,extractjpgfromraw=commands.getstatusoutput(extractjpgfromrawcommand)
                    self.LastPictureName=nbphoto[-1].split(".")[-2]+".thumb.jpg"
                #print self.LastPictureName
		self.IsInitialised=True
                self.HasPicture = True
            except IndexError or TypeError :
                self.IsInitialised=False
                self.parent.Update_Label_informations(self.tr("Camera not initialized, please retry"),not self.IsInitialised)
                self.HasPicture = False
            #print "numero derniere photo", numeroDernierePhoto
        
            
           
            #print self.tr("Last Picture"), str(self.LastPictureName),self.tr("is numbered "), self.LastPictureNumber #Ex: IMG_6769.JPG
 
    def UploadLastPicture(self,dir):
        """Upload Last Image in a file"""
        #print dir
        os.chdir(dir)
        UploadLastPictureCommand=str("gphoto2 -p " + str(self.LastPictureNumber))
        #print "Upload command ", UploadLastPictureCommand
        
        status,recupPhoto=commands.getstatusoutput(UploadLastPictureCommand)
	#print recupPhoto
        time.sleep(1)
	if recupPhoto.split(".")[-1]!="CR2":
		self.LastPictureName = recupPhoto.split()[-1]
		#print "jpg",self.LastPictureName
	else :
		extractjpgfromrawcommand ="dcraw -e "+recupPhoto.split()[-1]
		#print extractjpgfromrawcommand
		status,extractjpgfromraw=commands.getstatusoutput(extractjpgfromrawcommand)
		self.LastPictureName=recupPhoto.split()[-1].split(".")[-2]+".thumb.jpg"
		#print "ici",self.LastPictureName
        
class StartQT4(QMainWindow):
    def __init__(self, parent=None,):
        QMainWindow.__init__(self)
        #some ugly things
        self.IDRegion = 0
        self.dic={}
        self.camera_name_latest = self.tr("No Camera ")
        

        self.pyfocusdir = os.path.dirname(os.getcwd())+"/.pyfocus"
        print self.pyfocusdir
        ######QT
        QWidget.__init__(self, parent)
        self.ui = Ui_pyfocus_MainWindow()
        self.ui.setupUi(self)
        self.ui.label_image.setPixmap(QPixmap("./images/fond.jpg"))
        self.ui.actionDownload_last_picture.setIcon(QIcon("./icons/capture.png"))
        #self.ui.actionCapture_Picture.setIcon(QIcon("./icons/download.png"))
        QObject.connect(self.ui.actionDownload_last_picture,SIGNAL("activated()"), self.download_picture)
        QObject.connect(self,SIGNAL("camera_present(bool)"), self.update_camera_state)

        
        
        self.label_logo = QLabel(self.ui.centralwidget)
        self.label_logo.setGeometry(QRect(280,-5,32,32))
        self.label_logo.setText(" ")
        self.camera = camera(self)
    
        self.dialog = StartQTdialog4(self)
        
        self.dialog.pyfocusdir = self.pyfocusdir

        
        self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection, not self.camera.IsConnected)
        


    
    def Update_Label_informations(self, text,logo=False):
        """allow multiple messages on label"""
        self.ui.label_information_camera.setText(QString(text))
        
        if logo :
            self.label_logo.setPixmap(QPixmap("./icons/warning.png"))
        else :
            self.label_logo.setText(" ")

    
    def mouseReleaseEvent(self, event):
        """draw a rectangle near click and zoom it"""
        #print "OK bis"
        if self.camera.HasPicture == True :
            dic={}
            self.dic_region = {}
            #print self.tr("mouse clicked on "), event.x(), event.y()
            y_ = event.y()
            x_ = event.x()
            #height issue
            x1,y1,x2,y2 =x_-50, y_-50, x_+50, y_+50
            if x1 <0 or x2 <0 or y1 <0 or y2 <0 :
                #print self.tr("bad selection. near extrems")
                self.Update_Label_informations(self.tr("Please, choose another star"),True)
                
                
            else :
                image=QImage(self.camera.LastPictureName)
                #x,y=image.size().width(), image.size().height()
		if "thumb" not in self.camera.LastPictureName:
			rect = QRect(int(x1/self.coeff_x)+95, int(y1/self.coeff_y)-100, 200, 200)
		#	print "jpg"
		else :
		#	print "raw thulmb"
			rect = QRect(int(x1/self.coeff_x), int(y1/self.coeff_y)-100, 200, 200)
                #print rect.x(), rect.y(), rect.width(), rect.height()
                self.dialog.rect = rect #need for next captures
                IDRegion = 1
                region = image.copy(rect)
                self.star = star(IDRegion, region)
                self.update_dialog_focus(self.star)
        else :
            self.Update_Label_informations(self.tr("No Picture loaded",True))

    def update_dialog_focus(self, star):
        """upadte focus dialog with last region"""
        self.dialog.star = star
        self.dialog.expose_Capture("actual", star.image, star.number)
        for i in self.dialog.stars_picture :
            i.hide()
            i.close()
        self.dialog.show()
    
    
    def update_camera_state(self,camera_present):
        #print "DEBUG camera_present", camera_present
        
        self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection, not self.camera.IsConnected)
            #print self.camera_name_latest, self.camera.name
        if camera_present:
            if self.camera.isAutomated==True:
                #if self.camera.name != self.camera_name_latest:#allow multiple camera to be plugged. combox in dialog is changed dynamically
		if self.dialog.ui.combo_shutter_speed_list.count() < 2:
		    for index, shutterspeed in self.camera.shutter_speed_list.items():
                     #   print "index, shutterspeed", index, shutterspeed
                        self.dialog.ui.combo_shutter_speed_list.insertItem(int(index),str(shutterspeed)+self.tr(" seconds"))
                self.camera_name_latest = self.camera.name
                self.dialog.ui.Button_NewCapture.setEnabled(1)
                self.dialog.ui.combo_shutter_speed_list.setEnabled(1)
                self.dialog.ui.label_infos.setEnabled(1)
            else :
                self.dialog.ui.Button_NewCapture.setEnabled(0)
                self.dialog.ui.combo_shutter_speed_list.setEnabled(0)
                self.dialog.ui.label_infos.setEnabled(0)


    def download_picture(self):
        """download last taken picture from camera, expose it and give a zoom if defined"""
        self.camera.WhichLastPicture()
        #self.camera.camera_state()
        if self.camera.IsConnected==False :
            #print self.tr("No Camera detected : can't Upload")
            self.Update_Label_informations(self.tr("No Camera detected"),True)
            #self.avert("Please, plug the camera please")
        else :
            #test la presence de la derniere photo
            if self.camera.IsInitialised :
                chemin =self.pyfocusdir+"/picture/"+self.camera.LastPictureName
                #print chemin
                if os.path.isfile(chemin)==True :
                    self.ExposedImage(self.camera.LastPictureName)
                    self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection+ " : "+str(self.camera.LastPictureName), not self.camera.IsConnected)
                
                else:
                    self.camera.UploadLastPicture(self.pyfocusdir+"/picture")
                   # print "self.camera.LastPictureName", self.camera.LastPictureName
		    self.ExposedImage(self.camera.LastPictureName)
                    self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection, not self.camera.IsConnected)
                    
    def ExposedImage(self,picture):
        """expose Image given in argument on label_image widget and calcul picture informations"""
        os.chdir(self.pyfocusdir+"/picture")
	if picture.split(".")[-1]!="CR2":
		image=QImage(picture)
	else :
	#	print "Raw picture detected"
		stat,out = commands.getstatusoutput("dcraw -e "+picture)
		picture= picture.split(".")[0]+".thumb.jpg"
		image=QImage(picture)
	#print
	self.coeff_y = 600.0/(image.size().height())
	self.coeff_x = 800.0/(image.size().width())
        #print 0,0,image.size().width(),image.size().height()
        rect = QRect(0,0,800,600)
        	#print rect
        image_800_600 = image.scaled(800,600,Qt.KeepAspectRatio)
        image_800_600 = image_800_600.copy(rect)
        self.ui.label_image.setPixmap(QPixmap.fromImage(image_800_600))

class star_draw(QWidget):
    def __init__(self, parent, star):
        QWidget.__init__(self, parent)
        self.centre = star.centre_abs
        self.width = star.width
        self.setGeometry(0,0,200,200)
    def paintEvent(self, event):
        #print "self.centre, self.width", self.centre, self.width
        r=QRect(int(self.centre[0]-self.width), int(self.centre[1]-self.width), int(2*self.width), int(2*self.width))
        painter = QPainter()
        
        painter.begin(self)
	painter.setPen(Qt.red)
        
        painter.drawEllipse(r)
        painter.end()


class star(QObject):
    """this object is a star, select by pyfocus and displayed by dialog"""
    def __init__(self, IDRegion, region):
        QObject.__init__(self)
        self.name = ""
        self.number = IDRegion
        self.fwhm = 0
        self.image = region

class Label_Select(QLabel):
    def __init__(self,parent):
        QLabel.__init__(self,parent)
        self.parent = parent
        self.setGeometry(QRect(0,0,200,200))
        self.setAutoFillBackground(False)
        self.setCursor(Qt.CrossCursor)
        self.p1 =[-1,-1]
        
    def mousePressEvent(self, event):
        if event.button() != 1:
            self.p1=(-1,-1)
            self.close()
        self.p1 = (event.x(),event.y())
        #print self.p1
    
    def paintEvent(self, event):
        painter = QPainter()
        
        painter.begin(self)
        #painter.drawPixmap(0,0,self.pix)
	painter.setPen(Qt.red)
        if self.p1[0] >= 0:
	    painter.drawLine(self.p1[0], self.p1[1], self.p2[0], self.p2[1])
        painter.end()
    
    def mouseMoveEvent(self, event):
        self.p2 = (event.x() + 1, self.p1[1])
        self.update()
        #print self.p2
        
    def mouseReleaseEvent(self, event):
        if event.button() == 1 and self.p1[0] >= 0:
            self.p2 = (event.x() + 1, event.y() + 1)
            self.parent.point_1 = ((self.p1[0],self.p1[1]))
            self.parent.point_2 = ((self.p2[0],self.p2[1]))
        self.parent.emit(SIGNAL('selection_finished()'))
        self.close()

class StartQTdialog4(QDialog):
    def __init__(self, parent ):
        QDialog.__init__(self)
        self.star=None
        self.dic = {}
        self.parent=parent
        #QWidget.__init__(self, parent)
        self.ui = Ui_Dialog_zoom()
        self.stars_picture = []
        self.ui.setupUi(self)
        self.camera=self.parent.camera
        self.ui.Button_NewCapture.setEnabled(0)
        self.ui.combo_shutter_speed_list.setEnabled(0)
        self.ui.label_infos.setEnabled(0)
        QObject.connect(self.ui.Button_make_reference,SIGNAL("clicked()"),self.make_reference)
        QObject.connect(self.ui.Button_make_reference_2,SIGNAL("clicked()"),self.make_reference_from_list)
        #self.dialog.label_actual_pic.setPixmap(QPixmap.fromImage(ImageQt.ImageQt(region)))
        QObject.connect(self.ui.Button_NewCapture,SIGNAL("clicked()"),self.take_capture)
        
        QObject.connect(self.ui.Button_Manual_Capture,SIGNAL("clicked()"),self.update_manual_capture)
        QObject.connect(self.ui.Button_fwhm,SIGNAL("clicked()"),self.select_star)
        
        QObject.connect(self.ui.doubleSpinBox,SIGNAL("valueChanged(double)"),self.choose_last_picture)

        self.ui.doubleSpinBox.setMinimum(1)
    
    def qimage2numpy(self,image):
        data=[]
        y,x=image.height(),image.width()
        #print x,y
        handle, imageFile = tempfile.mkstemp(".png")
        #print imageFile
        image.save(imageFile)
        
        os.close(handle)
        
        im = Image.open(imageFile)
        im = ImageOps.grayscale(im)
        data =im.getdata()
        data=array(data)
        #print data.shape,type(data)
        return array(data),x,y
    
    def iter_correl(self,champ,x_begin,y_begin, x_end,y_end, pas,ref):
        list_correl=[]
        #r=0
        #temps=[]
        for i in arange(x_begin,x_end):
            if i+21<(x_end-x_begin) : #
                for j in arange(y_begin,y_end):
                    if j+21<y_end-y_begin :
                        if i*j%pas == 0 :
                            #o = time.time()
                            champ_crop = champ[i:i+21,j:j+21]
                            #if r==0 :
                                #temps.append("temps de crop : "+str(time.time()-tempo))
                            #if r==0 :
                                #tempo = time.time()
                            b=champ_crop.copy()
                            #if r==0 :
                                #temps.append("temps de copy() : "+str(time.time()-tempo))
                            
                            try :
                                b.shape=(1,21*21)
                                y2=b
                                #if r==0 :
                                    #tempo = time.time()
                                a = corrcoef(ref,y2)
                                list_correl.append(a[0,1])
                                #if r==0 :
                                    #temps.append("temps de calcul coeff : "+str(time.time()-tempo))
                                    #r=1
                            except ValueError:
                                print i,j
                                
                        else :
                            list_correl.append(0)
        #print temps
        #print list_correl
        return list_correl
    
    def correl(self, list_correl,champ):
        index_max = list_correl.index(max(list_correl))
        largeur_matrice = sqrt(len(list_correl))

        #print list_correl
        X_centre = int(index_max/largeur_matrice)+10
        Y_centre = index_max-(X_centre-10)*largeur_matrice +10

        star_crop = champ[X_centre-10:X_centre+10,Y_centre-10:Y_centre+10]
        
        params = self.star_ref.fitgaussian(star_crop)
        return params

    
    def select_star(self):
        """select a star in the field. Star choosen is the best correlation with predefined star"""
        #temps=[]
       
        self.star_ref=Star_Ref(self)
        try :
            champ = self.dic[self.star.number] #picture shown
        except KeyError :
            champ = self.star.image
      
        champ,X,Y = self.qimage2numpy(champ) #make a numpy array from image

          #initialise la liste des coeff
        b =champ.shape
        champ.shape = X,Y
       # print type(champ), X,Y, b,champ
        #tempoo = time.time()

        list_correl=self.iter_correl(champ,0,0, 200,200,6,self.star_ref.data)

        #temps.append("temps de boucle total : "+str(time.time()-tempoo))
        for i in arange(0,len(list_correl)):
            list_correl[i]=abs(list_correl[i])
            if list_correl[i]=="nan" :
                list_correl[i] = 0
        #print list_correl
        max_correl = max(list_correl)
        #print "max_correl", max_correl
        index_max = list_correl.index(max(list_correl))
        largeur_matrice = sqrt(len(list_correl))

        X_centre = int(index_max/largeur_matrice)+10
        Y_centre = index_max-(X_centre-10)*largeur_matrice +10
        
        if max_correl>0.65:
            params = self.correl(list_correl,champ)

            self.star.centre_abs = (Y_centre, X_centre)

            height, center_x, center_y, width_x, width_y = params
            #print "height,width_x, width_y", height,width_x, width_y
            width = (width_x+ width_y)/2
            self.star.fwhm = 2.355*width
            self.star.width = width
            self.ui.label_fwhm.setText(self.tr("FWHM = "+str("%.0f") % self.star.fwhm + "px"))
            self.expose_Capture("actual", self.star.image, self.star.number)
            a=star_draw(self.ui.label_actual_pic, self.star)
            #print "show star"
            self.stars_picture.append(a)
            a.show()
            
        else :
            self.ui.label_fwhm.setText(self.tr("No Star detected"))
    
        #print temps
        
    def update_manual_capture(self):
        """update all Labels with last taken picture"""
        if self.camera.IsConnected==False:
            self.ui.label_manual_capture.setText(self.tr("camera not connected"))
        else :
            self.ui.label_manual_capture.setText(self.tr("Downloading picture"))
            self.update_new_taken_picture()
            self.ui.label_manual_capture.setText(self.tr("Picture updated"))
            
    def choose_last_picture(self, event):
        #print self.dic
        #print "key", int(self.ui.doubleSpinBox.value())
        image=self.dic[int(self.ui.doubleSpinBox.value())]
        self.expose_Capture("last", image, self.ui.doubleSpinBox.value())
        
        
    def take_capture(self):
        """verify camera existence then send a capture order"""
        if self.camera.IsConnected==False:
            #print self.tr("please plug a camera")
            self.ui.label_infos.setText(self.tr("power On Camera"))
        
        elif  self.ui.combo_shutter_speed_list.currentText()==self.tr("Not defined"):
            self.ui.label_infos.setText(self.tr("Choose an exposure"))
        
        else :
            self.ui.Button_fwhm.setEnabled(1)
            index = self.ui.combo_shutter_speed_list.currentIndex()+1
            #print "index_", index
            status , output = commands.getstatusoutput(' gphoto2 -F 1  --set-config shutterspeed='+  str(index)) #this is to deblock camera... Gphoto bug
            time.sleep(1)
            status , output = commands.getstatusoutput(' gphoto2 -F 1  --set-config shutterspeed='+  str(index)+ ' --capture-image')
            waittime = str(self.ui.combo_shutter_speed_list.currentText()).split()[0]
            time.sleep(int(float(waittime)+3)) # 3 seconds to take care of process
            
            self.update_new_taken_picture()
    
    def new_picture_common(self):
            self.dic[self.star.number]=self.star.image
            self.star.number+=1
            self.do_New_Star_Picture()
            self.expose_Capture("actual", self.star.image, self.star.number)
            #print "self.camera.LastPictureName", self.camera.LastPictureName
	    self.parent.ExposedImage(self.camera.LastPictureName)
            if self.ui.checkBox_keep_star.isChecked() :
                self.select_star()
    
    def update_new_taken_picture(self):
        if self.ui.label_reference_pic.text()==self.tr("No Reference"):
            self.make_reference()
            self.new_picture_common()

        
        else :
            self.new_picture_common()
        
        if self.star.number==2:
            image=self.dic[1]
            self.expose_Capture("last", image, 1)
        else :
            self.star.number
             
    
    def expose_Capture(self, place, image, number):
        label = "label_"+place+"_pic"
        labelinfo=label+"_info"
        getattr(self.ui,label).setPixmap(QPixmap.fromImage(image))
        
        if place=="actual" : #update spinBox
            self.ui.doubleSpinBox.setMaximum(number)
            getattr(self.ui,labelinfo).setText(self.tr("try number ")+str(number))
        elif place=="reference" :
            getattr(self.ui,labelinfo).setText(self.tr("reference : ")+str(number))
        elif place=="last":
            getattr(self.ui,labelinfo).setText(self.tr("star nb ")+str(int(number)))
            
            
    
    def do_New_Star_Picture(self):
        self.camera.LastPictureNumber= int(self.camera.LastPictureNumber)+1
        self.camera.LastPictureNumber = str(self.camera.LastPictureNumber)
        dir = self.pyfocusdir+"/picture"
        self.camera.UploadLastPicture(dir)
        image = QImage(self.camera.LastPictureName)
	if "thumb" in self.camera.LastPictureName:
            region = image.copy(self.rect)
            #amliorer ici la seleciton, faire un crop puis augmenter

        else :
	    region = image.copy(self.rect)
        self.star.image = region
        self.dic[self.star.number]=self.star.image
    
    def make_reference_from_list(self):
        
        image=self.dic[int(self.ui.doubleSpinBox.value())]
        self.expose_Capture("reference", image, int(self.ui.doubleSpinBox.value()))
        
    
    def make_reference(self):
        """put actual picture as reference"""
        if self.star==None :
           pass
           # print self.tr("not possible : no star defined")
        else :
            self.expose_Capture("reference", self.star.image, self.star.number)
        
        
if __name__ == "__main__":

    
    app = QApplication(sys.argv)

    ### ##intialize directory
    pyfocusdir_install= os.path.dirname(os.getcwd())
    home = os.getenv("HOME")
    os.chdir(home)
    pyfocusdir=home+"/.pyfocus"
    print pyfocusdir
    if os.path.exists(pyfocusdir):
        print "directory ~/.pyfocus exists"
    else:
        print "directory ~/.pyfocus has to be created"
        os.mkdir(pyfocusdir)
        os.mkdir(pyfocusdir+ "/images")
        os.mkdir(pyfocusdir+ "/icons")
        os.mkdir(pyfocusdir+ "/picture")
        os.mkdir(pyfocusdir+ "/lang")
        #os.mkdir(pyfocusdir+ "/focus_thumbs")
        copy_commands='cp -R '+pyfocusdir_install+'/* '+pyfocusdir+"/"
        print pyfocusdir_install
        print copy_commands
        status,output=commands.getstatusoutput(copy_commands)
        #print self.tr("directory ~/.pyfocus created and picture copied")
    os.chdir(pyfocusdir)
    #self.pyfocusdir = pyfocusdir

    dir_ = pyfocusdir
    #translation
    locale = QLocale.system().name()
    print locale
    #print "pyfocus_" + locale
    qtTranslator = QTranslator()
    if qtTranslator.load("qt_" + locale):
        app.installTranslator(qtTranslator)
    appTranslator = QTranslator()
    print dir_+"/lang/pyfocus_" + locale
    if appTranslator.load(dir_+"/lang/pyfocus_" + locale):
        
        app.installTranslator(appTranslator)
    dbus.mainloop.qt.DBusQtMainLoop(set_as_default=True)
    windows = StartQT4()
    windows.show()
    sys.exit(app.exec_())
