#from scipy import *
#from numpy import *
#from pylab import *
#from numpy import *
from scipy import optimize, mgrid, indices, exp, arange, ravel
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from math import sqrt

class Star_Ref(QObject):
    def __init__(self,parent):
        Xin, Yin = mgrid[0:21, 0:21]
        data = self.gaussian(150, 10, 10, 3, 3)(Xin, Yin)

        (height, x, y, width_x, width_y) = 200, 10, 10, 5, 5
        
        data.shape=1,21*21
        self.data = data
                        
    def gaussian(self,height, center_x, center_y, width_x, width_y):
        """Returns a gaussian function with the given parameters"""
        width_x = float(width_x)
        width_y = float(width_y)

        return lambda x,y: height*exp(-(((center_x-x)/width_x)**2+((center_y-y)/width_y)**2)/2)
                    
    def moments(self, data):
        """Returns (height, x, y, width_x, width_y)
        the gaussian parameters of a 2D distribution by calculating its
        moments """
        total = data.sum()
        X, Y = indices(data.shape)
        x = (X*data).sum()/total
        y = (Y*data).sum()/total
        col = data[:, int(y)]
        width_x = sqrt(abs((arange(col.size)-y)**2*col).sum()/col.sum())
        row = data[int(x), :]
        width_y = sqrt(abs((arange(row.size)-x)**2*row).sum()/row.sum())
        height = data.max()
        return height, x, y, width_x, width_y

    def fitgaussian(self,data):
        """Returns (height, x, y, width_x, width_y)
        the gaussian parameters of a 2D distribution found by a fit"""
        params = self.moments(data)
        print "params", params
        errorfunction = lambda p: ravel(self.gaussian(*p)(*indices(data.shape)) -
                                    data)
        p, success = optimize.leastsq(errorfunction, params)
        return p
                    
    
class Champ(QObject):
    def __init__(self,parent):
        Xin, Yin = mgrid[0:101, 0:101]
        params =(15, 50, 80, 4, 4) #height, center_x, center_y, width_x, width_y
        data = self.gaussian(*params)(Xin, Yin)
        data.shape=1,101*101
        self.data = data
    
    def gaussian(self,height, center_x, center_y, width_x, width_y):
        """Returns a gaussian function with the given parameters"""
        width_x = float(width_x)
        width_y = float(width_y)
        return lambda x,y: height*exp(
                    -(((center_x-x)/width_x)**2+((center_y-y)/width_y)**2)/2)

                    
                    

#star_ref=Star_Ref(None)
#champ=Champ(None)

#list_correl=[]  #initialise la liste des coeff
#champ.data.shape=101,101 #remet le champ en matrice
##print type(champ.data)
#for i in arange(100):
     #if i+21<=101 : #
         #for j in arange(100):   
            #y1 = star_ref.data  #recupere l'etoile de reference en ligne
            #if j+21<=101 : 
                
                #champ_crop = champ.data[i:i+21,j:j+21] 
                #b=champ_crop.copy()
                #try :
                    #b.shape=(1,21*21) 
                    #y2=b
                    #a = corrcoef(y1,y2)
                    #list_correl.append(a[0,1])
                #except ValueError:
                    #print i,j

#for i in arange(0,len(list_correl)):
    #list_correl[i]=abs(list_correl[i])

##print max(list_correl), list_correl.index(max(list_correl))
#index_max = list_correl.index(max(list_correl))
#largeur_matrice = sqrt(len(list_correl))

#X_centre = int(index_max/largeur_matrice)+10
#Y_centre = index_max-(X_centre-10)*largeur_matrice +10

##print X_centre, Y_centre

##tentative de fitting
#etoile_crop = champ.data[X_centre-10:X_centre+10,Y_centre-10:Y_centre+10]
#params = star_ref.fitgaussian(etoile_crop)
#fit = star_ref.gaussian(*params)
#print params
